from os import remove
import json
from os.path import join, basename
from tempfile import gettempdir, gettempprefix
from typing import Union, Dict, List

from .source import Source


def read_json(source: Source, path: str) -> Union[Dict, List]:
    """ Helper to easily read a file on a source as JSON and decode it.
    """
    out_filename = join(gettempdir(), basename(path))
    try:
        source.get_file(path, out_filename)
        with open(out_filename) as f:
            data = json.load(f)
    finally:
        remove(out_filename)
    return data
